Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TiXmlBase Class Reference

`#include <tinyxml.h>`

Inheritance diagram for TiXmlBase:

[legend]
Collaboration diagram for TiXmlBase:

[legend]
List of all members.

## Public Member Functions
| TiXmlBase ()
virtual | ~TiXmlBase ()
virtual void | Print (FILE *cfile, int depth) const=0
int | Row () const
int | Column () const
| See Row().
## Static Public Member Functions
void | SetCondenseWhiteSpace (bool condense)
bool | IsWhiteSpaceCondensed ()
| Return the current white space setting.
## Protected Types
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_OUT_OF_MEMORY, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_STRING_COUNT }
## Protected Member Functions
virtual void | StreamOut (TiXmlOutStream *) const=0
virtual const char * | Parse (const char *p, TiXmlParsingData *data)=0
## Static Protected Member Functions
const char * | SkipWhiteSpace (const char *)
bool | IsWhiteSpace (int c)
const char * | ReadName (const char *p, TiXmlString *name)
const char * | ReadText (const char *in, TiXmlString *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase)
const char * | GetEntity (const char *in, char *value)
const char * | GetChar (const char *p, char *_value)
void | PutString (const TiXmlString &str, TiXmlOutStream *out)
void | PutString (const TiXmlString &str, TiXmlString *out)
bool | StringEqual (const char *p, const char *endTag, bool ignoreCase)
## Protected Attributes
TiXmlCursor | location
## Static Protected Attributes
const char * | errorString [TIXML_ERROR_STRING_COUNT]
## Private Types
enum | { NUM_ENTITY = 5, MAX_ENTITY_LENGTH = 6 }
## Static Private Attributes
Entity | entity [NUM_ENTITY]
bool | condenseWhiteSpace = true
## Friends
class | TiXmlNode
class | TiXmlElement
class | TiXmlDocument

## Detailed Description

TiXmlBase is a base class for every class in TinyXml. It does little except to establish that TinyXml classes can be printed and provide some utility functions.

In XML, the document and elements can contain other elements and other types of nodes.

    	A Document can contain:	Element	(container or leaf)
    							Comment (leaf)
    							Unknown (leaf)
    							Declaration( leaf )

    	An Element can contain:	Element (container or leaf)
    							Text	(leaf)
    							Attributes (not on tree)
    							Comment (leaf)
    							Unknown (leaf)

    	A Decleration contains: Attributes (not on tree)

## Member Enumeration Documentation

anonymous enum`[protected]`

  | Enumeration values:
  TIXML_NO_ERROR |
  TIXML_ERROR |
  TIXML_ERROR_OPENING_FILE |
  TIXML_ERROR_OUT_OF_MEMORY |
  TIXML_ERROR_PARSING_ELEMENT |
  TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME |
  TIXML_ERROR_READING_ELEMENT_VALUE |
  TIXML_ERROR_READING_ATTRIBUTES |
  TIXML_ERROR_PARSING_EMPTY |
  TIXML_ERROR_READING_END_TAG |
  TIXML_ERROR_PARSING_UNKNOWN |
  TIXML_ERROR_PARSING_COMMENT |
  TIXML_ERROR_PARSING_DECLARATION |
  TIXML_ERROR_DOCUMENT_EMPTY |
  TIXML_ERROR_STRING_COUNT |

anonymous enum`[private]`

  | Enumeration values:
  NUM_ENTITY |
  MAX_ENTITY_LENGTH |

## Constructor & Destructor Documentation

TiXmlBase::TiXmlBase | ( |  | ) | `[inline]`

virtual TiXmlBase::~TiXmlBase | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

int TiXmlBase::Column | ( |  | ) | const`[inline]`

| See Row().

const char* TiXmlBase::GetChar | ( | const char * | p,
|  | char * | _value
| ) | `[inline, static, protected]`

const char * TiXmlBase::GetEntity | ( | const char * | in,
|  | char * | value
| ) | `[static, protected]`

bool TiXmlBase::IsWhiteSpace | ( | int | c | ) | `[inline, static, protected]`

bool TiXmlBase::IsWhiteSpaceCondensed | ( |  | ) | `[inline, static]`

| Return the current white space setting.

virtual const char* TiXmlBase::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data
| ) | `[protected, pure virtual]`

| Implemented in TiXmlAttribute, TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

virtual void TiXmlBase::Print | ( | FILE * | cfile,
|  | int | depth
| ) | const`[pure virtual]`

| All TinyXml classes can print themselves to a filestream. This is a formatted print, and will insert tabs and newlines. (For an unformatted stream, use the << operator.) Implemented in TiXmlAttribute, TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

void TiXmlBase::PutString | ( | const TiXmlString & | str,
|  | TiXmlString * | out
| ) | `[static, protected]`

void TiXmlBase::PutString | ( | const TiXmlString & | str,
|  | TiXmlOutStream * | out
| ) | `[static, protected]`

const char * TiXmlBase::ReadName | ( | const char * | p,
|  | TiXmlString * | name
| ) | `[static, protected]`

const char * TiXmlBase::ReadText | ( | const char * | in,
|  | TiXmlString * | text,
|  | bool | ignoreWhiteSpace,
|  | const char * | endTag,
|  | bool | ignoreCase
| ) | `[static, protected]`

int TiXmlBase::Row | ( |  | ) | const`[inline]`

| Return the position, in the original source file, of this node or attribute. The row and column are 1-based. (That is the first row and first column is 1,1). If the returns values are 0 or less, then the parser does not have a row and column value. Generally, the row and column value will be set when the TiXmlDocument::Load(), TiXmlDocument::LoadFile(), or any TiXmlNode::Parse() is called. It will NOT be set when the DOM was created from operator>>. The values reflect the initial load. Once the DOM is modified programmatically (by adding or changing nodes and attributes) the new values will NOT update to reflect changes in the document. There is a minor performance cost to computing the row and column. Computation can be disabled if TiXmlDocument::SetTabSize() is called with 0 as the value. See also: TiXmlDocument::SetTabSize()

void TiXmlBase::SetCondenseWhiteSpace | ( | bool | condense | ) | `[inline, static]`

| The world does not agree on whether white space should be kept or not. In order to make everyone happy, these global, static functions are provided to set whether or not TinyXml will condense all white space into a single space or not. The default is to condense. Note changing this values is not thread safe.

const char * TiXmlBase::SkipWhiteSpace | ( | const char * |  | ) | `[static, protected]`

virtual void TiXmlBase::StreamOut | ( | TiXmlOutStream * |  | ) | const`[protected, pure virtual]`

| Implemented in TiXmlAttribute, TiXmlElement, TiXmlComment, TiXmlText, TiXmlDeclaration, TiXmlUnknown, and TiXmlDocument.

bool TiXmlBase::StringEqual | ( | const char * | p,
|  | const char * | endTag,
|  | bool | ignoreCase
| ) | `[static, protected]`

## Friends And Related Function Documentation

friend class TiXmlDocument`[friend]`

| Reimplemented in TiXmlNode.

friend class TiXmlElement`[friend]`

| Reimplemented in TiXmlNode, and TiXmlText.

friend class TiXmlNode`[friend]`

## Member Data Documentation

bool TiXmlBase::condenseWhiteSpace = true`[static, private]`

TiXmlBase::Entity TiXmlBase::entity`[static, private]`

| Initial value:
    {
        { "&amp;",  5, '&' },
        { "&lt;",   4, '<' },
        { "&gt;",   4, '>' },
        { "&quot;", 6, '\"' },
        { "&apos;", 6, '\'' }
    }

const char * TiXmlBase::errorString`[static, protected]`

| Initial value:
    {
        "No error",
        "Error",
        "Failed to open file",
        "Memory allocation failed.",
        "Error parsing Element.",
        "Failed to read Element name",
        "Error reading Element value.",
        "Error reading Attributes.",
        "Error: empty tag.",
        "Error reading end tag.",
        "Error parsing Unknown.",
        "Error parsing Comment.",
        "Error parsing Declaration.",
        "Error document empty."
    }

TiXmlCursor TiXmlBase::location`[protected]`

The documentation for this class was generated from the following files:

- tinyxml.h
- tinyxml.cpp
- tinyxmlerror.cpp
- tinyxmlparser.cpp